package sun.reflect;

import java.lang.reflect.Field;

class UnsafeStaticObjectFieldAccessorImpl extends UnsafeStaticFieldAccessorImpl
{
    UnsafeStaticObjectFieldAccessorImpl(Field field) {
        super(field);
    }
    
    @Override
    public Object get(Object o) throws IllegalArgumentException {
        return UnsafeStaticObjectFieldAccessorImpl.unsafe.getObject(this.base, this.fieldOffset);
    }
    
    @Override
    public boolean getBoolean(Object o) throws IllegalArgumentException {
        throw this.newGetBooleanIllegalArgumentException();
    }
    
    @Override
    public byte getByte(Object o) throws IllegalArgumentException {
        throw this.newGetByteIllegalArgumentException();
    }
    
    @Override
    public char getChar(Object o) throws IllegalArgumentException {
        throw this.newGetCharIllegalArgumentException();
    }
    
    @Override
    public short getShort(Object o) throws IllegalArgumentException {
        throw this.newGetShortIllegalArgumentException();
    }
    
    @Override
    public int getInt(Object o) throws IllegalArgumentException {
        throw this.newGetIntIllegalArgumentException();
    }
    
    @Override
    public long getLong(Object o) throws IllegalArgumentException {
        throw this.newGetLongIllegalArgumentException();
    }
    
    @Override
    public float getFloat(Object o) throws IllegalArgumentException {
        throw this.newGetFloatIllegalArgumentException();
    }
    
    @Override
    public double getDouble(Object o) throws IllegalArgumentException {
        throw this.newGetDoubleIllegalArgumentException();
    }
    
    @Override
    public void set(Object o, Object x) throws IllegalArgumentException, IllegalAccessException {
        if (this.isFinal) {
            this.throwFinalFieldIllegalAccessException(x);
        }
        if (x != null && !this.field.getType().isAssignableFrom(x.getClass())) {
            this.throwSetIllegalArgumentException(x);
        }
        UnsafeStaticObjectFieldAccessorImpl.unsafe.putObject(this.base, this.fieldOffset, x);
    }
    
    @Override
    public void setBoolean(Object o, boolean b) throws IllegalArgumentException, IllegalAccessException {
        this.throwSetIllegalArgumentException(b);
    }
    
    @Override
    public void setByte(Object o, byte b) throws IllegalArgumentException, IllegalAccessException {
        this.throwSetIllegalArgumentException(b);
    }
    
    @Override
    public void setChar(Object o, char c) throws IllegalArgumentException, IllegalAccessException {
        this.throwSetIllegalArgumentException(c);
    }
    
    @Override
    public void setShort(Object o, short n) throws IllegalArgumentException, IllegalAccessException {
        this.throwSetIllegalArgumentException(n);
    }
    
    @Override
    public void setInt(Object o, int n) throws IllegalArgumentException, IllegalAccessException {
        this.throwSetIllegalArgumentException(n);
    }
    
    @Override
    public void setLong(Object o, long n) throws IllegalArgumentException, IllegalAccessException {
        this.throwSetIllegalArgumentException(n);
    }
    
    @Override
    public void setFloat(Object o, float n) throws IllegalArgumentException, IllegalAccessException {
        this.throwSetIllegalArgumentException(n);
    }
    
    @Override
    public void setDouble(Object o, double n) throws IllegalArgumentException, IllegalAccessException {
        this.throwSetIllegalArgumentException(n);
    }
}
